Index: /NEMO/trunk/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 13295)
@@ -568,5 +568,5 @@
       zwnd_j(:,:) = 0._wp
       CALL wnd_cyc( kt, zwnd_i, zwnd_j )    ! add analytical tropical cyclone (Vincent et al. JGR 2012)
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          zwnd_i(ji,jj) = pwndi(ji,jj) + zwnd_i(ji,jj)
          zwnd_j(ji,jj) = pwndj(ji,jj) + zwnd_j(ji,jj)
@@ -576,5 +576,5 @@
 #else
       ! ... scalar wind module at T-point (not masked)
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          wndm(ji,jj) = SQRT(  pwndi(ji,jj) * pwndi(ji,jj) + pwndj(ji,jj) * pwndj(ji,jj)  )
       END_2D
@@ -628,5 +628,5 @@
          !     use scalar version of gamma_moist() ...
          IF( ln_tpot ) THEN
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                ztpot(ji,jj) = ptair(ji,jj) + gamma_moist( ptair(ji,jj), zqair(ji,jj) ) * rn_zqt
             END_2D
@@ -690,5 +690,5 @@
 
       IF( ln_abl ) THEN         !==  ABL formulation  ==!   multiplication by rho_air and turbulent fluxes computation done in ablstp
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             zztmp = zU_zu(ji,jj)
             wndm(ji,jj)   = zztmp                   ! Store zU_zu in wndm to compute ustar2 in ablmod
@@ -710,5 +710,5 @@
          pevp(:,:) = pevp(:,:) * tmask(:,:,1)
 
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             IF( wndm(ji,jj) > 0._wp ) THEN
                zztmp = taum(ji,jj) / wndm(ji,jj)
@@ -728,5 +728,5 @@
          IF( ln_crt_fbk ) THEN   ! aply eq. 10 and 11 of Renault et al. 2020 (doi: 10.1029/2019MS001715)
             zstmax = MIN( rn_stau_a * 3._wp + rn_stau_b, 0._wp )   ! set the max value of Stau corresponding to a wind of 3 m/s (<0)
-            DO_2D_01_01   ! end at jpj and jpi, as ztau_j(ji,jj+1) ztau_i(ji+1,jj) used in the next loop
+            DO_2D( 0, 1, 0, 1 )   ! end at jpj and jpi, as ztau_j(ji,jj+1) ztau_i(ji+1,jj) used in the next loop
                zstau = MIN( rn_stau_a * wndm(ji,jj) + rn_stau_b, zstmax )   ! stau (<0) must be smaller than zstmax
                ztau_i(ji,jj) = ztau_i(ji,jj) + zstau * ( 0.5_wp * ( pu(ji-1,jj  ) + pu(ji,jj) ) - puatm(ji,jj) )
@@ -739,5 +739,5 @@
          !     Note the use of 0.5*(2-umask) in order to unmask the stress along coastlines
          !     Note that coastal wind stress is not used in the code... so this extra care has no effect
-         DO_2D_00_00              ! start loop at 2, in case ln_crt_fbk = T
+         DO_2D( 0, 0, 0, 0 )              ! start loop at 2, in case ln_crt_fbk = T
             utau(ji,jj) = 0.5 * ( 2. - umask(ji,jj,1) ) * ( ztau_i(ji,jj) + ztau_i(ji+1,jj  ) ) &
                &              * MAX(tmask(ji,jj,1),tmask(ji+1,jj,1))
@@ -828,5 +828,5 @@
 
       ! use scalar version of L_vap() for AGRIF compatibility
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          zqla(ji,jj) = - L_vap( ztskk(ji,jj) ) * pevp(ji,jj)    ! Latent Heat flux !!GS: possibility to add a global qla to avoid recomputation after abl update
       END_2D
@@ -933,5 +933,5 @@
       ! ------------------------------------------------------------ !
       ! C-grid ice dynamics :   U & V-points (same as ocean)
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          wndm_ice(ji,jj) = SQRT( pwndi(ji,jj) * pwndi(ji,jj) + pwndj(ji,jj) * pwndj(ji,jj) )
       END_2D
@@ -959,10 +959,10 @@
          ! ---------------------------------------------------- !
          ! supress moving ice in wind stress computation as we don't know how to do it properly...
-         DO_2D_01_01    ! at T point 
+         DO_2D( 0, 1, 0, 1 )    ! at T point 
             putaui(ji,jj) = rhoa(ji,jj) * zcd_dui(ji,jj) * pwndi(ji,jj)
             pvtaui(ji,jj) = rhoa(ji,jj) * zcd_dui(ji,jj) * pwndj(ji,jj)
          END_2D
          !
-         DO_2D_00_00    ! U & V-points (same as ocean).
+         DO_2D( 0, 0, 0, 0 )    ! U & V-points (same as ocean).
             ! take care of the land-sea mask to avoid "pollution" of coastal stress. p[uv]taui used in frazil and  rheology 
             zztmp1 = 0.5_wp * ( 2. - umask(ji,jj,1) ) * MAX( tmask(ji,jj,1),tmask(ji+1,jj  ,1) )
@@ -978,5 +978,5 @@
          zztmp1 = 11637800.0_wp
          zztmp2 =    -5897.8_wp
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             pcd_dui(ji,jj) = zcd_dui (ji,jj)
             pseni  (ji,jj) = wndm_ice(ji,jj) * Ch_ice(ji,jj)
@@ -1233,5 +1233,5 @@
          !
          DO jl = 1, jpl
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                zhe = ( rn_cnd_s * phi(ji,jj,jl) + rcnd_i * phs(ji,jj,jl) ) * zfac                            ! Effective thickness
                IF( zhe >=  zfac2 )   zgfac(ji,jj,jl) = MIN( 2._wp, 0.5_wp * ( 1._wp + LOG( zhe * zfac3 ) ) ) ! Enhanced conduction factor
@@ -1248,5 +1248,5 @@
       !
       DO jl = 1, jpl
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             !
             zkeff_h = zfac * zgfac(ji,jj,jl) / &                                    ! Effective conductivity of the snow-ice system divided by thickness
@@ -1396,5 +1396,5 @@
       zqi_sat(:,:) =                  q_sat( ptm_su(:,:), pslp(:,:) )   ! saturation humidity over ice   [kg/kg]
       !
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ! Virtual potential temperature [K]
          zthetav_os = zst(ji,jj)    * ( 1._wp + rctv0 * zqo_sat(ji,jj) )   ! over ocean
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_algo_coare3p0.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 13295)
@@ -394,5 +394,5 @@
       !!-------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zw = pwnd(ji,jj)   ! wind speed
@@ -430,5 +430,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zta = pzeta(ji,jj)
@@ -481,5 +481,5 @@
       REAL(wp) :: zta, zphi_h, zphi_c, zpsi_k, zpsi_c, zf, zc, zstab
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zta = pzeta(ji,jj)
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_algo_coare3p6.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 13295)
@@ -430,5 +430,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zta = pzeta(ji,jj)
@@ -481,5 +481,5 @@
       REAL(wp) :: zta, zphi_h, zphi_c, zpsi_k, zpsi_c, zf, zc, zstab
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zta = pzeta(ji,jj)
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ecmwf.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 13295)
@@ -410,5 +410,5 @@
       REAL(wp) :: zzeta, zx, ztmp, psi_unst, psi_stab, stab
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zzeta = MIN( pzeta(ji,jj) , 5._wp ) !! Very stable conditions (L positif and big!):
@@ -455,5 +455,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
       !
       zzeta = MIN(pzeta(ji,jj) , 5._wp)   ! Very stable conditions (L positif and big!):
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ncar.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 13295)
@@ -241,5 +241,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          zw  = pw10(ji,jj)
@@ -277,5 +277,5 @@
       REAL(wp) :: zx2, zx, zstab   ! local scalars
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          zx2 = SQRT( ABS( 1._wp - 16._wp*pzeta(ji,jj) ) )
          zx2 = MAX( zx2 , 1._wp )
@@ -308,5 +308,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          zx2 = SQRT( ABS( 1._wp - 16._wp*pzeta(ji,jj) ) )
          zx2 = MAX( zx2 , 1._wp )
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_phy.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_phy.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_phy.F90	(revision 13295)
@@ -181,5 +181,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ztc  = ptak(ji,jj) - rt0   ! air temp, in deg. C
          ztc2 = ztc*ztc
@@ -270,5 +270,5 @@
       INTEGER  ::   ji, jj         ! dummy loop indices
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          gamma_moist_vctr(ji,jj) = gamma_moist_sclr( ptak(ji,jj), pqa(ji,jj) )
       END_2D
@@ -315,5 +315,5 @@
       !!-------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          zqa = (1._wp + rctv0*pqa(ji,jj))
@@ -351,5 +351,5 @@
       !!-------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          zqa = 0.5_wp*(pqa(ji,jj)+pssq(ji,jj))                                        ! ~ mean q within the layer...
@@ -448,5 +448,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ze_sat =  e_sat_sclr( ptak(ji,jj) )
@@ -473,5 +473,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ze = prha(ji,jj)*e_sat_sclr(ptak(ji,jj))
          q_air_rh(ji,jj) = ze*reps0/(pslp(ji,jj) - (1. - reps0)*ze)
@@ -511,5 +511,5 @@
       INTEGER  ::   ji, jj     ! dummy loop indices
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
 
          zdt = pTa(ji,jj) - pTs(ji,jj) ;  zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
@@ -621,5 +621,5 @@
       IF( PRESENT(pfact_evap) ) zfact_evap = pfact_evap
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
 
          CALL BULK_FORMULA_SCLR( pzu, pTs(ji,jj), pqs(ji,jj), pTa(ji,jj), pqa(ji,jj), &
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_skin_coare.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 13295)
@@ -89,5 +89,5 @@
       REAL(wp) :: zQabs, zdlt, zfr, zalfa, zqlat, zus
       !!---------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
 
          zQabs = pQnsol(ji,jj) ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
@@ -156,5 +156,5 @@
       ztime = REAL(nsec_day,wp)/(24._wp*3600._wp) ! time of current time step since 00:00 for current day (UTC) -> ztime = 0 -> 00:00 / ztime = 0.5 -> 12:00 ...
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
 
          l_exit       = .FALSE.
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_skin_ecmwf.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 13295)
@@ -95,5 +95,5 @@
       REAL(wp) :: zQabs, zdlt, zfr, zalfa, zus
       !!---------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
 
          zQabs = pQnsol(ji,jj) ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
@@ -173,5 +173,5 @@
       IF( PRESENT(pustk) ) l_pustk_known = .TRUE.
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
 
          zHwl = Hz_wl(ji,jj) ! first guess for warm-layer depth (and unique..., less advanced than COARE3p6 !)
Index: /NEMO/trunk/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbccpl.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbccpl.F90	(revision 13295)
@@ -1170,5 +1170,5 @@
             !                              
             IF( srcv(jpr_otx1)%clgrid == 'T' ) THEN
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   frcv(jpr_otx1)%z3(ji,jj,1) = 0.5 * ( frcv(jpr_otx1)%z3(ji+1,jj  ,1) + frcv(jpr_otx1)%z3(ji,jj,1) )
                   frcv(jpr_oty1)%z3(ji,jj,1) = 0.5 * ( frcv(jpr_oty1)%z3(ji  ,jj+1,1) + frcv(jpr_oty1)%z3(ji,jj,1) )
@@ -1194,5 +1194,5 @@
          ! => need to be done only when otx1 was changed
          IF( llnewtx ) THEN
-            DO_2D_00_00
+            DO_2D( 0, 0, 0, 0 )
                zzx = frcv(jpr_otx1)%z3(ji-1,jj  ,1) + frcv(jpr_otx1)%z3(ji,jj,1)
                zzy = frcv(jpr_oty1)%z3(ji  ,jj-1,1) + frcv(jpr_oty1)%z3(ji,jj,1)
@@ -1219,5 +1219,5 @@
          IF( llnewtau ) THEN 
             zcoef = 1. / ( zrhoa * zcdrag ) 
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                frcv(jpr_w10m)%z3(ji,jj,1) = SQRT( frcv(jpr_taum)%z3(ji,jj,1) * zcoef )
             END_2D
@@ -1549,5 +1549,5 @@
             p_tauj(:,:) = frcv(jpr_ity1)%z3(:,:,1)
          CASE( 'T' )
-            DO_2D_00_00
+            DO_2D( 0, 0, 0, 0 )
                ! take care of the land-sea mask to avoid "pollution" of coastal stress. p[uv]taui used in frazil and  rheology 
                zztmp1 = 0.5_wp * ( 2. - umask(ji,jj,1) ) * MAX( tmask(ji,jj,1),tmask(ji+1,jj  ,1) )
@@ -2365,10 +2365,10 @@
             SELECT CASE( TRIM( sn_snd_crt%cldes ) )
             CASE( 'oce only'             )      ! C-grid ==> T
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   zotx1(ji,jj) = 0.5 * ( uu(ji,jj,1,Kmm) + uu(ji-1,jj  ,1,Kmm) )
                   zoty1(ji,jj) = 0.5 * ( vv(ji,jj,1,Kmm) + vv(ji  ,jj-1,1,Kmm) ) 
                END_2D
             CASE( 'weighted oce and ice' )      ! Ocean and Ice on C-grid ==> T  
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)  
                   zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj)
@@ -2378,5 +2378,5 @@
                CALL lbc_lnk_multi( 'sbccpl', zitx1, 'T', -1.0_wp, zity1, 'T', -1.0_wp )
             CASE( 'mixed oce-ice'        )      ! Ocean and Ice on C-grid ==> T
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)   &
                      &         + 0.5 * ( u_ice(ji,jj  )     + u_ice(ji-1,jj    )     ) *  fr_i(ji,jj)
@@ -2442,10 +2442,10 @@
           SELECT CASE( TRIM( sn_snd_crtw%cldes ) ) 
           CASE( 'oce only'             )      ! C-grid ==> T 
-             DO_2D_00_00
+             DO_2D( 0, 0, 0, 0 )
                 zotx1(ji,jj) = 0.5 * ( uu(ji,jj,1,Kmm) + uu(ji-1,jj  ,1,Kmm) ) 
                 zoty1(ji,jj) = 0.5 * ( vv(ji,jj,1,Kmm) + vv(ji , jj-1,1,Kmm) )  
              END_2D
           CASE( 'weighted oce and ice' )      ! Ocean and Ice on C-grid ==> T   
-             DO_2D_00_00
+             DO_2D( 0, 0, 0, 0 )
                 zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)   
                 zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj) 
@@ -2455,5 +2455,5 @@
              CALL lbc_lnk_multi( 'sbccpl', zitx1, 'T', -1.0_wp,  zity1, 'T', -1.0_wp ) 
           CASE( 'mixed oce-ice'        )      ! Ocean and Ice on C-grid ==> T  
-             DO_2D_00_00
+             DO_2D( 0, 0, 0, 0 )
                 zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)   & 
                    &         + 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj) 
Index: /NEMO/trunk/src/OCE/SBC/sbcdcy.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcdcy.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcdcy.F90	(revision 13295)
@@ -110,5 +110,5 @@
 
       imask_night(:,:) = 0
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ztmpm = 0._wp
          IF( ABS(rab(ji,jj)) < 1. ) THEN         ! day duration is less than 24h
@@ -193,5 +193,5 @@
 
          zsin = SIN( zdecrad )   ;   zcos = COS( zdecrad )
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             ztmp = rad * gphit(ji,jj)
             raa(ji,jj) = SIN( ztmp ) * zsin
@@ -202,5 +202,5 @@
          ! rab to test if the day time is equal to 0, less than 24h of full day
          rab(:,:) = -raa(:,:) / rbb(:,:)
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             IF( ABS(rab(ji,jj)) < 1._wp ) THEN         ! day duration is less than 24h
                ! When is it night?
@@ -226,5 +226,5 @@
          !         Avoid possible infinite scaling factor, associated with very short daylight
          !         periods, by ignoring periods less than 1/1000th of a day (ticket #1040)
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             IF( ABS(rab(ji,jj)) < 1._wp ) THEN         ! day duration is less than 24h
                rscal(ji,jj) = 0.0_wp
Index: /NEMO/trunk/src/OCE/SBC/sbcflx.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcflx.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcflx.F90	(revision 13295)
@@ -129,5 +129,5 @@
          ELSE                  ;   qsr(:,:) =          sf(jp_qsr)%fnow(:,:,1)
          ENDIF
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             utau(ji,jj) = sf(jp_utau)%fnow(ji,jj,1)
             vtau(ji,jj) = sf(jp_vtau)%fnow(ji,jj,1)
@@ -143,5 +143,5 @@
          !                                                        ! module of wind stress and wind speed at T-point
          zcoef = 1. / ( zrhoa * zcdrag )
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             ztx = utau(ji-1,jj  ) + utau(ji,jj) 
             zty = vtau(ji  ,jj-1) + vtau(ji,jj) 
Index: /NEMO/trunk/src/OCE/SBC/sbcice_cice.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcice_cice.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcice_cice.F90	(revision 13295)
@@ -217,5 +217,5 @@
 ! T point to U point
 ! T point to V point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          fr_iu(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji+1,jj))*umask(ji,jj,1)
          fr_iv(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji,jj+1))*vmask(ji,jj,1)
@@ -312,5 +312,5 @@
 ! x comp of wind stress (CI_1)
 ! U point to F point
-         DO_2D_10_11
+         DO_2D( 1, 0, 1, 1 )
             ztmp(ji,jj) = 0.5 * (  fr_iu(ji,jj) * utau(ji,jj)      &
                                  + fr_iu(ji,jj+1) * utau(ji,jj+1) ) * fmask(ji,jj,1)
@@ -320,5 +320,5 @@
 ! y comp of wind stress (CI_2)
 ! V point to F point
-         DO_2D_11_10
+         DO_2D( 1, 1, 1, 0 )
             ztmp(ji,jj) = 0.5 * (  fr_iv(ji,jj) * vtau(ji,jj)      &
                                  + fr_iv(ji+1,jj) * vtau(ji+1,jj) ) * fmask(ji,jj,1)
@@ -335,5 +335,5 @@
             qla_ice(:,:,1)= - ( emp_ice(:,:)+sprecip(:,:) ) * rLsub
 ! End of temporary code
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                IF(fr_i(ji,jj).eq.0.0) THEN
                   DO jl=1,ncat
@@ -437,5 +437,5 @@
 ! x comp and y comp of surface ocean current
 ! U point to F point
-      DO_2D_10_11
+      DO_2D( 1, 0, 1, 1 )
          ztmp(ji,jj)=0.5*(ssu_m(ji,jj)+ssu_m(ji,jj+1))*fmask(ji,jj,1)
       END_2D
@@ -443,5 +443,5 @@
 
 ! V point to F point
-      DO_2D_11_10
+      DO_2D( 1, 1, 1, 0 )
          ztmp(ji,jj)=0.5*(ssv_m(ji,jj)+ssv_m(ji+1,jj))*fmask(ji,jj,1)
       END_2D
@@ -467,5 +467,5 @@
 ! x comp and y comp of sea surface slope (on F points)
 ! T point to F point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          ztmp(ji,jj)=0.5 * (  (zpice(ji+1,jj  )-zpice(ji,jj  )) * r1_e1u(ji,jj  )    &
             &               + (zpice(ji+1,jj+1)-zpice(ji,jj+1)) * r1_e1u(ji,jj+1)  ) * fmask(ji,jj,1)
@@ -474,5 +474,5 @@
 
 ! T point to F point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          ztmp(ji,jj)=0.5 * (  (zpice(ji  ,jj+1)-zpice(ji  ,jj)) * r1_e2v(ji  ,jj)    &
             &               + (zpice(ji+1,jj+1)-zpice(ji+1,jj)) * r1_e2v(ji+1,jj)  ) *  fmask(ji,jj,1)
@@ -503,5 +503,5 @@
       ss_iou(:,:)=0.0
 ! F point to U point
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ss_iou(ji,jj) = 0.5 * ( ztmp1(ji,jj-1) + ztmp1(ji,jj) ) * umask(ji,jj,1)
       END_2D
@@ -513,5 +513,5 @@
 ! F point to V point
 
-      DO_2D_10_00
+      DO_2D( 1, 0, 0, 0 )
          ss_iov(ji,jj) = 0.5 * ( ztmp1(ji-1,jj) + ztmp1(ji,jj) ) * vmask(ji,jj,1)
       END_2D
@@ -597,5 +597,5 @@
       CALL lbc_lnk( 'sbcice_cice', qsr , 'T', 1.0_wp )
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          nfrzmlt(ji,jj)=MAX(nfrzmlt(ji,jj),0.0)
       END_2D
@@ -621,5 +621,5 @@
 ! T point to U point
 ! T point to V point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          fr_iu(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji+1,jj))*umask(ji,jj,1)
          fr_iv(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji,jj+1))*vmask(ji,jj,1)
@@ -981,5 +981,5 @@
 
       pn(:,:)=0.0
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          pn(ji,jj)=pc(ji+1-ji_off,jj+1-jj_off,1)
       END_2D
Index: /NEMO/trunk/src/OCE/SBC/sbcice_if.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcice_if.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcice_if.F90	(revision 13295)
@@ -109,5 +109,5 @@
 
          ! Flux and ice fraction computation
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             !
             zt_fzp  = fr_i(ji,jj)                        ! freezing point temperature
Index: /NEMO/trunk/src/OCE/SBC/sbcrnf.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcrnf.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcrnf.F90	(revision 13295)
@@ -209,5 +209,5 @@
       IF( ln_rnf_depth .OR. ln_rnf_depth_ini ) THEN      !==   runoff distributed over several levels   ==!
          IF( ln_linssh ) THEN    !* constant volume case : just apply the runoff input flow
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                DO jk = 1, nk_rnf(ji,jj)
                   phdivn(ji,jj,jk) = phdivn(ji,jj,jk) - ( rnf(ji,jj) + rnf_b(ji,jj) ) * zfact * r1_rho0 / h_rnf(ji,jj)
@@ -215,5 +215,5 @@
             END_2D
          ELSE                    !* variable volume case
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                h_rnf(ji,jj) = 0._wp
                DO jk = 1, nk_rnf(ji,jj)                           ! recalculates h_rnf to be the depth in metres
@@ -361,5 +361,5 @@
          !
          nk_rnf(:,:) = 0                               ! set the number of level over which river runoffs are applied
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             IF( h_rnf(ji,jj) > 0._wp ) THEN
                jk = 2
@@ -374,5 +374,5 @@
             ENDIF
          END_2D
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             h_rnf(ji,jj) = 0._wp
             DO jk = 1, nk_rnf(ji,jj)
@@ -404,5 +404,5 @@
          WHERE( zrnfcl(:,:,1) > 0._wp )  h_rnf(:,:) = zacoef * zrnfcl(:,:,1)   ! compute depth for all runoffs
          !
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             IF( zrnfcl(ji,jj,1) > 0._wp ) THEN
                jk = mbkt(ji,jj)
@@ -412,5 +412,5 @@
          !
          nk_rnf(:,:) = 0                       ! number of levels on which runoffs are distributed
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             IF( zrnfcl(ji,jj,1) > 0._wp ) THEN
                jk = 2
@@ -423,5 +423,5 @@
          END_2D
          !
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             h_rnf(ji,jj) = 0._wp
             DO jk = 1, nk_rnf(ji,jj)
Index: /NEMO/trunk/src/OCE/SBC/sbcssr.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcssr.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcssr.F90	(revision 13295)
@@ -95,5 +95,5 @@
             !
             IF( nn_sstr == 1 ) THEN                                   !* Temperature restoring term
-               DO_2D_11_11
+               DO_2D( 1, 1, 1, 1 )
                   zqrp = rn_dqdt * ( sst_m(ji,jj) - sf_sst(1)%fnow(ji,jj,1) ) * tmask(ji,jj,1)
                   qns(ji,jj) = qns(ji,jj) + zqrp
@@ -105,5 +105,5 @@
               ! use fraction of ice ( fr_i ) to adjust relaxation under ice if nn_sssr_ice .ne. 1
               ! n.b. coefice is initialised and fixed to 1._wp if nn_sssr_ice = 1
-               DO_2D_11_11
+               DO_2D( 1, 1, 1, 1 )
                   SELECT CASE ( nn_sssr_ice )
                     CASE ( 0 )    ;  coefice(ji,jj) = 1._wp - fr_i(ji,jj)              ! no/reduced damping under ice
@@ -115,5 +115,5 @@
             IF( nn_sssr == 1 ) THEN                                   !* Salinity damping term (salt flux only (sfx))
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
-               DO_2D_11_11
+               DO_2D( 1, 1, 1, 1 )
                   zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
                      &        *   coefice(ji,jj)            &      ! Optional control of damping under sea-ice
@@ -126,5 +126,5 @@
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
                zerp_bnd = rn_sssr_bnd / rday                          !       -              -    
-               DO_2D_11_11
+               DO_2D( 1, 1, 1, 1 )
                   zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
                      &        *   coefice(ji,jj)            &      ! Optional control of damping under sea-ice
Index: /NEMO/trunk/src/OCE/SBC/sbcwave.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcwave.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbcwave.F90	(revision 13295)
@@ -113,5 +113,5 @@
       IF( ll_st_bv_li ) THEN   ! (Eq. (19) in Breivik et al. (2014) )
          zfac = 2.0_wp * rpi / 16.0_wp
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             ! Stokes drift velocity estimated from Hs and Tmean
             ztransp = zfac * hsw(ji,jj)*hsw(ji,jj) / MAX( wmp(ji,jj), 0.0000001_wp )
@@ -121,5 +121,5 @@
             zk_t(ji,jj) = ABS( tsd2d(ji,jj) ) / MAX( ABS( 5.97_wp*ztransp ), 0.0000001_wp )
          END_2D
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )
             zk_u(ji,jj) = 0.5_wp * ( zk_t(ji,jj) + zk_t(ji+1,jj) )
             zk_v(ji,jj) = 0.5_wp * ( zk_t(ji,jj) + zk_t(ji,jj+1) )
@@ -129,8 +129,8 @@
          END_2D
       ELSE IF( ll_st_peakfr ) THEN    ! peak wave number calculated from the peak frequency received by the wave model
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             zk_t(ji,jj) = ( 2.0_wp * rpi * wfreq(ji,jj) ) * ( 2.0_wp * rpi * wfreq(ji,jj) ) / grav
          END_2D
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )
             zk_u(ji,jj) = 0.5_wp * ( zk_t(ji,jj) + zk_t(ji+1,jj) )
             zk_v(ji,jj) = 0.5_wp * ( zk_t(ji,jj) + zk_t(ji,jj+1) )
@@ -143,5 +143,5 @@
       !                       !==  horizontal Stokes Drift 3D velocity  ==!
       IF( ll_st_bv2014 ) THEN
-         DO_3D_00_00( 1, jpkm1 )
+         DO_3D( 0, 0, 0, 0, 1, jpkm1 )
             zdep_u = 0.5_wp * ( gdept(ji,jj,jk,Kmm) + gdept(ji+1,jj,jk,Kmm) )
             zdep_v = 0.5_wp * ( gdept(ji,jj,jk,Kmm) + gdept(ji,jj+1,jk,Kmm) )
@@ -158,5 +158,5 @@
       ELSE IF( ll_st_li2017 .OR. ll_st_peakfr ) THEN
          ALLOCATE( zstokes_psi_u_top(jpi,jpj), zstokes_psi_v_top(jpi,jpj) )
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )
             zstokes_psi_u_top(ji,jj) = 0._wp
             zstokes_psi_v_top(ji,jj) = 0._wp
@@ -164,5 +164,5 @@
          zsqrtpi = SQRT(rpi)
          z_two_thirds = 2.0_wp / 3.0_wp
-         DO_3D_00_00( 1, jpkm1 )
+         DO_3D( 0, 0, 0, 0, 1, jpkm1 )
             zbot_u = ( gdepw(ji,jj,jk+1,Kmm) + gdepw(ji+1,jj,jk+1,Kmm) )  ! 2 * bottom depth
             zbot_v = ( gdepw(ji,jj,jk+1,Kmm) + gdepw(ji,jj+1,jk+1,Kmm) )  ! 2 * bottom depth
@@ -204,5 +204,5 @@
       !                       !==  vertical Stokes Drift 3D velocity  ==!
       !
-      DO_3D_01_01( 1, jpkm1 )
+      DO_3D( 0, 1, 0, 1, 1, jpkm1 )
          ze3divh(ji,jj,jk) = (  e2u(ji  ,jj) * e3u(ji  ,jj,jk,Kmm) * usd(ji  ,jj,jk)    &
             &                 - e2u(ji-1,jj) * e3u(ji-1,jj,jk,Kmm) * usd(ji-1,jj,jk)    &
@@ -263,5 +263,5 @@
       !
       IF( ln_tauw ) THEN
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )
             ! Stress components at u- & v-points
             utau(ji,jj) = 0.5_wp * ( tauw_x(ji,jj) + tauw_x(ji+1,jj) )
Index: /NEMO/trunk/src/OCE/STO/stopar.F90
===================================================================
--- /NEMO/trunk/src/OCE/STO/stopar.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/STO/stopar.F90	(revision 13295)
@@ -837,5 +837,5 @@
       REAL(wp) :: gran   ! Gaussian random number (forced KIND=8 as in kiss_gaussian)
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          CALL kiss_gaussian( gran )
          psto(ji,jj) = gran
@@ -855,5 +855,5 @@
       INTEGER  :: ji, jj
 
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          psto(ji,jj) = 0.5_wp * psto(ji,jj) + 0.125_wp * &
                            &  ( psto(ji-1,jj) + psto(ji+1,jj) +  &
Index: /NEMO/trunk/src/OCE/STO/stopts.F90
===================================================================
--- /NEMO/trunk/src/OCE/STO/stopts.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/STO/stopts.F90	(revision 13295)
@@ -95,5 +95,5 @@
       ! Eliminate any possible negative salinity
       DO jdof = 1, nn_sto_eos
-         DO_3D_11_11( 1, jpkm1 )
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
             pts_ran(ji,jj,jk,jp_sal,jdof) = MIN( ABS(pts_ran(ji,jj,jk,jp_sal,jdof)) ,  &
                                           &      MAX(pts(ji,jj,jk,jp_sal),0._wp) )     &
